#include "8421.h"
#include "alati.h"
#include "rezultat.h"
#include <stdexcept>
#include <iostream>
using namespace std;

		Broj8421::Broj8421(const string& x)  //Proveravamo moguci znak i od kojeg mesta krecemo da prevodimo cifre
		{
			if(!Alati::IspravanOperand(x))
				throw invalid_argument("Операнд није исправан");

			_Visak = 0;
			int pocetna=1;
			_Znak = '+';
			if (x[0] == '-')
				_Znak = '-';
			else if (x[0] == '+')
				_Znak = '+';
			else
				pocetna = 0;
			for (int i=pocetna; i<x.size(); i++)
				PrevediCifru(x[i]);  //prevodimo cifru po cifru i smestamo u string _Broj pomocu privatne metode
		}
		void Broj8421::KorigujBcdBroj(const int size)
		{
			//ova dva dela mogu malo da se poboljsaju koriscenjem STL-a
			int BrDodatihNula = size - _Broj.size();
			string pomocni;
			for (int i=0; i<BrDodatihNula; i++)  //pogledaj dal ovo moze da se uradi na laksi nacin!
				pomocni += '0';
			pomocni += _Broj;
			_Broj = pomocni;
		}
		void Broj8421::Skrati()  //metoda brise eventualne vodece bitovske nule
		{
			int i=0;
			while (_Broj[i] == '0') //pronalazimo poslednju vodecu bitovsku nulu
				i++;
			int visak = ((int)(i/4))*4;  //Odredjujemo koliko imamo pocetnih bitovskih nula viska
			string pomocni;
			for (i=visak; i<_Broj.size(); i++)  //u pomocni string smestamo novi broj
				pomocni += _Broj[i];
			_Broj = pomocni;  //ovde ga vracamo u _Broj
		}
		void Broj8421::OduzmiOd (BcdBroj& x, char Znak)
		{
			string Prenos;
			string PrvaRazlika;
			
			PrvaFazaOduzimanja(Prenos, PrvaRazlika, x);
			
			brezultat << "Први операнд је: ";	Alati::StampajBcdBroj(x);
			brezultat << "\nДруги операнд је:";	Alati::StampajBcdBroj(*this);
			
			brezultat << "\n ";					Alati::StampajBcdBroj(PrvaRazlika);
			brezultat << "са преносом\n ";		Alati::StampajBcdBroj(Prenos);
			brezultat << "\n";
			
			string KonacnaRazlika;
			KonacnaRazlika.resize(PrvaRazlika.size());
			
			DrugaFazaOduzimanja(Prenos, PrvaRazlika, KonacnaRazlika);
			
			brezultat << "\n";
			brezultat << Znak;					Alati::StampajBcdBroj(KonacnaRazlika);
		}
		
		void Broj8421::PrvaFazaOduzimanja(string& Prenos, string& PrvaRazlika, BcdBroj& x)
		{
			_Broj.size() > x.Duzina() ? x.KorigujBcdBroj(_Broj.size()) : KorigujBcdBroj(x.Duzina());
			int duzina = x.Duzina(); // svejedno, sada su iste duzine
			
			Prenos.resize(duzina);
			PrvaRazlika.resize(duzina);
			for (int i=0; i<duzina; i++)
				Prenos[i] = PrvaRazlika[i] = '0';  //incijalizujemo stringove da imaju pocetne nule
			
			for (int i=duzina-1; i>=0; i--)
			{
				int pom = x.VratiCifru(i)-'0' - _Broj[i]+'0' - Prenos[i]+'0';
				if (pom < 0)
				{
					Prenos[i-1] = '1';
					pom += 2;
				}
				PrvaRazlika[i] = pom + '0';
			}
			brezultat << "\n";
		}
		void Broj8421::DrugaFazaOduzimanja(string& Prenos, string& PrvaRazlika, string& KonacnaRazlika)
		{
			int TrenutniPrenos = 0; //privremeni prenos
			int VelikiPrenos = 0;
			for (int k=PrvaRazlika.size()/4; k!=0; k--) //Obradjujemo 4 po 4 binarne cifre
			{
				brezultat.zavrsiKorak();
				string pomocni; 		//cuva trenutna 4 bita koji se obradjuju
				int i=k*4-1;			//krecemo od poslednjih 4 bita
				for (int j=3; j>=0; j--)
					pomocni += PrvaRazlika[i-j];
				TrenutniPrenos = VelikiPrenos;
				
				Alati::StampajBeline(5*k-1); brezultat << VelikiPrenos << "\n";
				
				for (int j=3; j>=0; j--)
				{
					int temp;
					temp = pomocni[j]-'0' - TrenutniPrenos;
					TrenutniPrenos = 0;
					if (temp < 0)
					{
						TrenutniPrenos = 1;
						temp += 2;
					}
					pomocni[j] = temp + '0';
				}
				Alati::StampajBeline(5*k-4); brezultat << pomocni << "\n";
				
				VelikiPrenos = TrenutniPrenos;
				if (Prenos[i-4] == '1' && i != 3)
				{
					Alati::StampajBeline(5*k-4); brezultat << "0110\n";
					for (int j=3; j>=0; j--)
					{
						int temp;
						if (j==1 || j==2)
							temp = pomocni[j]-'0' - 1 - TrenutniPrenos;
						else
							temp = pomocni[j]-'0' - TrenutniPrenos;
						TrenutniPrenos = 0;
						if (temp < 0)
						{
							TrenutniPrenos = 1;
							temp += 2;
						}
						KonacnaRazlika[i-3+j] = temp + '0';
					}
					Alati::StampajRed(5*k-4, KonacnaRazlika, i-3, 4);
				}
				else
				{
					Alati::StampajBeline(5*k-4); brezultat << "0000\n";
					for (int j=0; j<=3; j++)
						KonacnaRazlika[i-3+j] = pomocni[j];
					Alati::StampajRed(5*k-4, KonacnaRazlika, i-3, 4);
				}
			}
			brezultat.zavrsiKorak();
		}
		
		void Broj8421::PrvaFazaSabiranja(string& Prenos, string& PrviZbir, BcdBroj& x)
		{
			//Korigujemo brojeve tako da se sastoje iz jednakog broja binarnih cifara
			_Broj.size() > x.Duzina() ? x.KorigujBcdBroj(_Broj.size()) : KorigujBcdBroj(x.Duzina());
			int duzina = x.Duzina(); // svejedno, sada su iste duzine
			
			duzina += 4; 				//povecavamo duzinu zbog stringa PrviZbir
			Prenos.resize(duzina);  	//Napomena: Prenos ce imati pocetne 3 cifre viska(nicem ne sluze)
			PrviZbir.resize(duzina);	//prvi zbir ce imati prve 3 cifre nule, ali ih pisemo zbog poravnanja
			for (int i=0; i<duzina; i++)
				Prenos[i] = PrviZbir[i] = '0';  //incijalizujemo stringove da imaju pocetne nule
					
			for (int i=duzina-1; i>=4; i--)  //idemo do 4 jer su posle toga sve nule
			{
				int CeoZbir = _Broj[i-4]-'0' + x.VratiCifru(i-4)-'0' + Prenos[i]-'0';
				PrviZbir[i] = CeoZbir % 2 + '0';
				Prenos[i-1] = (int)(CeoZbir/2) + '0';
				if (i==4)  //kad stignemo do binarne cifre najvece tezine, na njeno mesto postavljamo samo prenos
					PrviZbir[i-1] = Prenos[i-1];
			}
		}
		void Broj8421::DrugaFazaSabiranja(string& Prenos, string& PrviZbir, string& KonacanZbir)
		{
			int TrenutniPrenos = 0; //privremeni prenos
			int VelikiPrenos = 0; //Prenos sa jedne na drugu dekadnu cifru
			for (int k=PrviZbir.size()/4; k!=0; k--) //Obradjujemo 4 po 4 binarne cifre
			{
				brezultat.zavrsiKorak();

				string pomocni; 		//cuva trenutna 4 bita koji se obradjuju
				int i=k*4-1; 			//krecemo od poslednjih 4 bita
				for (int j=3; j>=0; j--)
					pomocni += PrviZbir[i-j];
				TrenutniPrenos = VelikiPrenos;
				
				Alati::StampajBeline(5*k-1);
				brezultat << VelikiPrenos << "\n";
				
				for (int j=3; j>=0; j--) //dodajemo prenos u pomocni
				{
					int temp;
					temp = pomocni[j]-'0' + TrenutniPrenos;
					pomocni[j] = temp%2 + '0';
					TrenutniPrenos = (int)(temp/2);
				}
				
				Alati::StampajBeline(5*k-4); brezultat << pomocni << "\n";
				
				VelikiPrenos = TrenutniPrenos;
				if ((Prenos[i-4] == '1') || (VeciOd9(pomocni))) //potrebna je korekcija
				{
					Alati::StampajBeline(5*k-4); brezultat << "0110\n";
					
					for (int j=3; j>=0; j--)
					{
						int temp;
						if (j==1 || j==2)
							temp = pomocni[j]-'0' + 1 + TrenutniPrenos;
						else
							temp = pomocni[j]-'0' + TrenutniPrenos;
						KonacanZbir[i-3+j] = temp%2 + '0';
						TrenutniPrenos = (int)(temp/2);
					}
					Alati::StampajRed(5*k-4, KonacanZbir, i-3, 4);
				}
				else //nije potrebna korekcija
				{
					Alati::StampajBeline(5*k-4); brezultat << "0000\n";
					
					for (int j=3; j>=0; j--)
					{
						int temp;
						temp = pomocni[j]-'0' + TrenutniPrenos;
						KonacanZbir[i-3+j] = temp%2 + '0';
						TrenutniPrenos = (int)(temp/2);
					}
					Alati::StampajRed(5*k-4, KonacanZbir, i-3, 4);
				}
				if (TrenutniPrenos == 1) //za slucaj da je bilo prenosa pri korekciji
					VelikiPrenos = 1;
			}
			brezultat.zavrsiKorak();
		}
