#include "rezultat.h"
#include "stdlib.h"
#include <stdexcept>

void Rezultat::clear()
{
    rez.clear();
    prikazan = 0;
}

void Rezultat::zavrsiKorak()
{
	std::string sTb;
    for(int i=0;i<korak.size();i++)
    {
       sTb += korak[i] + "\n";       
    }

    Glib::RefPtr<Gtk::TextBuffer> tb = Gtk::TextBuffer::create();
    if(rez.size() > 0) sTb = rez[rez.size()-1]->get_text() + "\n" + sTb;
    tb->set_text(sTb);
    rez.push_back(tb);
    korak.clear();
}

void Rezultat::zavrsiRed()
{
    std::string sRed;
    for(int i=0;i<red.size();i++)
    {
        sRed += red[i];
    }
    korak.push_back(sRed);
    red.clear();
}
     
Rezultat& Rezultat::operator<< (std::string str)
{
    int j = 0;	
    for (int i=0;i<str.size();i++)
    {
       if (str[i] == '\n')
       {
          if (i-j > 0) red.push_back(str.substr(j,i-j));
          zavrsiRed();
          j = i + 1;
       }
    }
    if(j<str.size()) red.push_back(str.substr(j,str.size()-j));
    return *this;
}

Rezultat& Rezultat::operator<< (char c)
{
    if(c == '\n')
    	zavrsiRed();
    else
    {
      char tmp[2];
      tmp[0] = c;
      tmp[1] = '\0';
      red.push_back(std::string(tmp));
    }
    return *this;
}

Rezultat& Rezultat::operator<< (int br)
{
    char tmp[25];
    sprintf(tmp, "%d", br);
    red.push_back(std::string(tmp));
    return *this;
}

Glib::RefPtr<Gtk::TextBuffer> Rezultat::PrikaziNaredni()
{   
    if(prikazan < rez.size())
    {
    	return rez[++prikazan-1];
    }
    else 
    	throw std::invalid_argument("Нема наредног корака.");
}

int Rezultat::BrojKoraka()
{
    return rez.size();
}

int Rezultat::PrikazanKorak()
{
    return prikazan;
}
